<?php
/*************************************
 * SPDX-FileCopyrightText: 2009-2020 Vtenext S.r.l. <info@vtenext.com> 
 * SPDX-License-Identifier: AGPL-3.0-only  
 ************************************/
global $app_strings, $mod_strings, $current_language, $currentModule, $current_user, $theme;
if ($_REQUEST['calc_nav'] == 'true' && $_REQUEST['get_all_ids'] == 'true'){
	echo get_allids(VteSession::get($currentModule.'_listquery'),$_REQUEST['ids_to_jump']); //crmv@181619
	die;
}
require_once('include/ListView/ListView.php');
require_once('include/utils/utils.php');
require_once('modules/CustomView/CustomView.php');
require_once('modules/RecycleBin/RecycleBinUtils.php');

global $adb, $table_prefix, $log, $list_max_entries_per_page;
$theme_path="themes/".$theme."/";
$image_path=$theme_path."images/";
require_once('modules/VteCore/layout_utils.php');	//crmv@30447

require("user_privileges/user_privileges_".$current_user->id.".php");

$smarty = new VteSmarty();

// Data from the below modules will not be allowed to restore
$skip_modules = array('Emails','Fax','Sms','Messages','ModComments','MyFiles','MyNotes'); // crmv@164122
$skip_tab_ids = array();
if (!empty($skip_modules)) {
	for($i=0; $i<count($skip_modules); $i++) {
		$tab_id = getTabid($skip_modules[$i]);
		if ($tab_id != null && $tab_id != '') $skip_tab_ids[] = $tab_id;
	}
}
$sql = 'SELECT tabid, name FROM '.$table_prefix.'_tab WHERE presence=0 AND isentitytype=1 ';
if (count($skip_tab_ids) > 0) {
	$sql .= ' AND tabid NOT IN ('. generateQuestionMarks($skip_tab_ids) .')';
}
$result =$adb->pquery($sql, array($skip_tab_ids));
$noofrows = $adb->num_rows($result);

$module_name =Array();
$module_labels = array();
$module_data =Array();

if($noofrows > 0) {
	for($x=0,$y=0; $x<$noofrows;$x++) {
		$tabid = $adb->query_result($result,$x,'tabid');
		if($is_admin || $profileGlobalPermission[2]==0 || $profileGlobalPermission[1]==0 || $profileTabsPermission[$tabid]==0) {
			$mod_name = $adb->query_result($result,$x,"name");
			$module_name[$y] = $mod_name;
			$module_labels[$mod_name] = getTranslatedString($mod_name, $mod_name);
			$y++;
		}
	}
}

asort($module_labels); // sort by label

if(isset($_REQUEST['selected_module']) && $_REQUEST['selected_module'] != '') {
	$select_module = vtlib_purify($_REQUEST['selected_module']);
	if (!in_array($select_module, $module_name)) {
		show_error_msg();
	}
} else {
	if (count($module_name) > 0) {
		reset($module_labels);
		$select_module = key($module_labels);
	} else {
		show_error_msg('no_permitted_modules');
	}	
}

$url_string = '';
if(isset($_REQUEST['query']) && $_REQUEST['query'] == 'true')
{
	list($where, $ustring) = explode("#@@#",RBSearch($select_module));

	// we have a query
	$url_string .="&query=true".$ustring;
	$log->info("Here is the where clause for the list view: $where");
	$smarty->assign("SEARCH_URL",$url_string);
				
}

$focus = CRMEntity::getInstance($select_module);

if(count($module_name) > 0)
{
	$cur_mod_view = new CustomView($select_module);
	
	//crmv@88734
	$queryGenerator = QueryGenerator::getInstance($select_module, $current_user);
	$queryGenerator->initForAllCustomView(); // crmv@95295
	$list_query = $queryGenerator->getQuery();
	//crmv@88734e

	$list_query = preg_replace("/".$table_prefix."_crmentity.deleted\s*=\s*0/i", $table_prefix.'_crmentity.deleted = 1', $list_query);
	//Search criteria added to the list Query
	if(isset($where) && $where != '')
	{
		$list_query .= ' AND '.$where;
	}
	VteSession::set($currentModule.'_listquery',$list_query); // crmv@181619
	
	$count_result = $adb->query( mkCountQuery($list_query));
	//crmv@88734
	if ($count_result) {
		$noofrows = $adb->query_result($count_result,0,"count");
	} else {
		$noofrows = 0;
	}
	//crmv@88734e

	$rb_listview_header = getListViewHeader($focus, $select_module, '','','','global',$cur_mod_view,'',true);
	$listview_header_search=getSearchListHeaderValues($focus,$select_module,$url_string,$sorder,$order_by,"",$cur_mod_view);
	$smarty->assign("SEARCHLISTHEADER", $listview_header_search);

	if(isset($_REQUEST['start']) && $_REQUEST['start'] != '')
		$start = vtlib_purify($_REQUEST['start']);
	else
		$start = 1;

	$navigation_array = getNavigationValues($start, $noofrows, $list_max_entries_per_page);

	// Setting the record count string
	//modified by rdhital
	$start_rec = $navigation_array['start'];
	$end_rec = $navigation_array['end_val']; 
	//By Raju Ends

	//limiting the query
	if ($start_rec ==0) 
		$limit_start_rec = 0;
	else
		$limit_start_rec = $start_rec -1;

	$list_result = $adb->limitQuery($list_query,$limit_start_rec,$list_max_entries_per_page);

	$record_string= $app_strings['LBL_SHOWING']." " .$start_rec." - ".$end_rec." " .$app_strings['LBL_LIST_OF'] ." ".$noofrows; //crmv@177675

	$navigationOutput = getTableHeaderSimpleNavigation($navigation_array, $url_string,"Recyclebin","index","");

	// crmv@84630
	$skipActions = true;
	$lvEntries = getListViewEntries($focus,$select_module,$list_result,$navigation_array,"","","","",$cur_mod_view,'','','',$skipActions);
	// crmv@84630e
}

$smarty->assign("NAVIGATION", $navigationOutput);
$smarty->assign("RECORD_COUNTS", $record_string);

//to get the field name that mentions the module
$query = "select fieldname from ".$table_prefix."_entityname where modulename =?";
$module_fielaname = $adb->query_result($adb->pquery($query, array($select_module)),0,'fieldname');

if(strpos($module_fielaname,','))
{
	$field_array = explode(',',$module_fielaname);
	$index_field = $field_array[0];
}
else
{
	$index_field = $module_fielaname;
}

$alphabetical = AlphabeticalSearch($currentModule,'index',$index_field,'true','basic',"","","","",$viewid);

$category = getParentTab();;

$check_button = Button_Check($_REQUEST['module']);
$check_button['EditView'] = 'no';
$smarty->assign("CHECK", $check_button);

$smarty->assign("ALPHABETICAL", $alphabetical);
$smarty->assign("NUMBER_MODULES",$noofrows);
$smarty->assign("MODULE_NAME",$module_name);
$smarty->assign("MODULE_LABELS",$module_labels);
$smarty->assign("SELECTED_MODULE",$select_module);
$smarty->assign("MODULE_DATA",$rb_listview_header);
$smarty->assign("MOD", $mod_strings);
$smarty->assign("MODULE",$currentModule);
$smarty->assign("CATEGORY",$category);
$smarty->assign("THEME",$theme);
$smarty->assign("IMAGE_PATH",$image_path);
$smarty->assign("APP", $app_strings);
$smarty->assign("CMOD", return_module_language($current_language,$select_module));
$smarty->assign("lvEntries", $lvEntries);

$smarty->assign("IS_ADMIN", $is_admin);
if (isset($_REQUEST["selected_ids"]))
{
  $smarty->assign("SELECTED_IDS_ARRAY", explode(";",$_REQUEST["selected_ids"]));
  $smarty->assign("SELECTED_IDS", $_REQUEST["selected_ids"]);
} 
if (isset($_REQUEST["all_ids"]))
{
  $smarty->assign("ALL_IDS", $_REQUEST["all_ids"]);
}

$smarty_ajax_template = vtlib_getModuleTemplate($currentModule,'RecycleBin.tpl');
$smarty_template = vtlib_getModuleTemplate($currentModule,'RecycleBinContents.tpl');

$sdk_custom_file = 'ListViewCustomisations';
if (isModuleInstalled('SDK')) {
    $tmp_sdk_custom_file = SDK::getFile($currentModule,$sdk_custom_file);
    if (!empty($tmp_sdk_custom_file)) {
    	$sdk_custom_file = $tmp_sdk_custom_file;
    }
}
@include("modules/$currentModule/$sdk_custom_file.php");

if ($_REQUEST['mode'] != 'ajax')
	$smarty->display($smarty_ajax_template);
else
	$smarty->display($smarty_template);
	
function show_error_msg($error_type='permission_denied') {
	global $theme;
	if ($error_type == 'permission_denied') {		
		echo "<link rel='stylesheet' type='text/css' href='themes/$theme/style.css'>";	
		echo "<table border='0' cellpadding='5' cellspacing='0' width='100%' height='450px'><tr><td align='center'>";
		echo "<div style='border: 3px solid rgb(153, 153, 153); background-color: rgb(255, 255, 255); width: 55%; position: relative; z-index: 10000000;'>
	
			<table border='0' cellpadding='5' cellspacing='0' width='98%'>
			<tbody><tr>
			<td rowspan='2' width='11%'><img src='" . vtecrm_imageurl('denied.gif', $theme) . "' ></td>
			<td style='border-bottom: 1px solid rgb(204, 204, 204);' nowrap='nowrap' width='70%'><span class='genHeaderSmall'>" 
				. getTranslatedString('LBL_PERMISSION') . "</span></td>
			</tr>
			<tr>
			<td class='small' align='right' nowrap='nowrap'>			   	
			<a href='javascript:window.history.back();'>" . getTranslatedString('LBL_GO_BACK') . "</a><br>
			</td>
			</tr>
			</tbody></table> 
			</div>";
		echo "</td></tr></table>";
		die();
	} else if ($error_type == 'no_permitted_modules') {		
		echo "<link rel='stylesheet' type='text/css' href='themes/$theme/style.css'>";	
		echo "<table border='0' cellpadding='5' cellspacing='0' width='100%' height='450px'><tr><td align='center'>";
		echo "<div style='border: 3px solid rgb(153, 153, 153); background-color: rgb(255, 255, 255); width: 55%; position: relative; z-index: 10000000;'>
	
			<table border='0' cellpadding='5' cellspacing='0' width='98%'>
			<tbody><tr>
			<td rowspan='2' width='11%'><img src='" . vtecrm_imageurl('empty.jpg', $theme) . "' ></td>
			<td style='border-bottom: 1px solid rgb(204, 204, 204);' nowrap='nowrap' width='70%'><span class='genHeaderSmall'>" 
				. getTranslatedString('LBL_NO_PERMITTED_MODULES') . "</span></td>
			</tr>
			</tbody></table> 
			</div>";
		echo "</td></tr></table>";
		die();		
	}
}

?>